Echo Request/Reply for DetNet Capability Discovery
Internet-Draft draft-tan-detnet-cap-discovery-02
Li Zhang
Huawei
China
zhangli344@huawei.com
Hongyi Huang
Huawei
China
hongyi.huang@huawei.com
Tianran Zhou
Huawei
China
zhoutianran@huawei.com
Wei Gao
CAICT
gaowei@caict.ac.cn
10 October 2024
Routing Area
detnet Working Group
DetNet
OAM
Ping
Echo request
Echo reply
This document describes an extension to the echo request/reply mechanisms used in IP, MPLS or other DetNet data plane environments, which can be used within the DetNet domain, allowing the ping initiator node to discover the enabled DetNet capabilities of each relay node of detnet service-sub layer, which including discovering DetNet relay nodes, collecting DetNet service sub-layer specific information from DetNet relay nodes, as well as discovering the locations of PREOF functions.
Introduction
[RFC8655] provides the overall architecture for Deterministic Networking (DetNet), which provides a capability to carry specified unicast or multicast data flows for real-time applications with extremely low data loss rates and bounded latency within a network domain. Currently DetNet operates on IP and MPLS data plane.
DetNet functionality is divided into two sub-layers. The DetNet service sub-layer provides DetNet service protection with functionalities and operation of PREOF, a collective name for Packet Replication, Elimination, and Ordering Functions. The DetNet forwarding sub-layer provides resource allocation for DetNet flows over paths provided by the underlying network.
[I-D.ietf-detnet-oam-framework] details the specific requirements of the Operation, Administration, and Maintenance (OAM) recommended to maintain a deterministic network. OAM for the DetNet MPLS data plane is described in [I-D.ietf-detnet-mpls-oam] and OAM for the DetNet IP data plane is described in [I-D.ietf-detnet-ip-oam].
[I-D.ietf-detnet-oam-framework] described the DetNet service sub-layer oam requirements of discovering DetNet relay nodes , collecting DetNet service sub-layer specific (e.g., configuration/operation/status) information from DetNet relay nodes, as well as discovering the locations of PREOF functions.
These requirements, could be satisfied using alternative technologies like NETCONF/YANG, IGP flooding or ping/traceroute. [I-D.varga-detnet-service-sub-layer-oam] introduced a ping/traceroute method, "DetNet Ping", and mentions that it could be used for discovering DetNet capabilities of DetNet relay nodes.
This document introduced extensions to DetNet Ping (echo request/reply) used in IP, MPLS or other DetNet data plane environments, which can be used within the DetNet domain, allowing the ping initiator node to discover the enabled DetNet capabilities of each relay node of detnet service-sub layer.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Terminology
The abbreviations used in this document are:
DetNet: Deterministic Networking
OAM: Operation, Administration, and Maintenance
PRF: Packet Replication Function
PEF: Packet Elimination Function
POF: Packet Ordering Function
PREOF: Packet Replication, Elimination and Ordering Function
DetNet Capability Discovery
DetNet Capability Discovery Operation
Once the DetNet PING initiator node is triggered to discover the enabled DetNet capabilities of each DetNet relay node, the initiator node will send DetNet echo requests that include the DetNet Capabilities Discovery Header.
First, with TTL equal to 1 to reach the closest node, which may be an DetNet relay node or not. Then with TTL equal to 2 to reach the second nearest node, which also may be an DetNet relay node or not.
And further, increasing by 1 the TTL every time the initiator node sends a new echo request. As a result, the echo requests sent by the initiator node will reach all nodes one by one along the transport path of DetNet service flow.
Alternatively, if the initiator node knows precisely all the DetNet relay nodes beforehand, once the initiator node is triggered to discover the enabled DetNet capabilities, it can send an echo request to each DetNet relay node directly, without TTL expiration.
DetNet Capability Discovery Header
For echo DetNet request/reply message used for DetNet capability discovery, DetNet capabilities information are delivered by several kinds of DetNet Capabilities Discovery Objects. This document introduces an abstract header which has the corresponding format depending on the type of DetNet data plane. The format of DetNet Capabilities Discovery Object is shown as below.
The Format of Mandatory Section of A BFD Control Packet

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    .                                                               .
    .            DetNet Capabilities Discovery Header               .
    .                                                               .
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    .                                                               .
    .            DetNet Capabilities Discovery Data                 .
    .                                                               .
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

DetNet Capabilities Discovery Header: abstract header of DetNet Capabilities Discovery Object, with varied length and format depending on the type of DetNet data plane.
DetNet Capabilities Discovery Data: detailed information of DetNet Capabilities Discovery Object, with fixed length and format depending on the type of Detnet capability.

DetNet Capabilities Discovery Objects
DetNet Capability Object
DetNet Capability Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                   DetNet Capability Flags             |S|F|I|O|
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Flags (4 bytes): DetNet Capability Flags
 * S: Service sub-layer capability
 * F: Forwarding sub-layer capability
 * I: Incoming flow configuration
 * O: Outgoing flow configuration

DetNet Relay Node Identifier Object
DetNet Node Identifier Object (MPLS)
DetNet Node Identifier Object (MPLS) Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                 Node ID               |     RESERVED    | OP  |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

  Node ID (20 bits): The value of the Node ID field identifies the DetNet node that originated the packet. It is same as defined in {{I-D.ietf-detnet-mpls-oam}}.
  OP (3 bits): Service operation on the node.
               0x00: No operation for DetNet service sub-layer
               0x01: Initiation for DetNet service sub-layer encapsulation
               0x02: Termination for DetNet service sub-layer encapsulation
               0x03: Relay(Swap) operation for DetNet service sub-layer

DetNet Node Identifier Object (IPv4)
DetNet Node Identifier Object (IPv4) Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                   IPv4 address (4 bytes)                      |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     | Prefix Length |                   RESERVED              | OP  |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

  IPv4 address(4 bytes): An IPv4 address. This address is treated as a prefix based on the prefix length value.
  Prefix length(1 bytes): Length in bits of the IPv4 prefix.
  OP (3 bits): Service operation on the node.
               0x00: No operation for DetNet service sub-layer
               0x01: Initiation for DetNet service sub-layer encapsulation
               0x02: Termination for DetNet service sub-layer encapsulation
               0x03: Relay(Swap) operation for DetNet service sub-layer

DetNet Node Identifier Object (IPv6)
DetNet Node Identifier Object (IPv6) Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                   IPv6 address (16 bytes)                     |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     | Prefix Length |                   RESERVED              | OP  |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

  IPv6 address: An IPv6 address. This address is treated as a prefix based on the prefix length value.
  Prefix length: Length in bits of the IPv6 prefix.
  OP (3 bits): Service operation on the node.
               0x00: No operation for DetNet service sub-layer
               0x01: Initiation for DetNet service sub-layer encapsulation
               0x02: Termination for DetNet service sub-layer encapsulation
               0x03: Relay(Swap) operation for DetNet service sub-layer

DetNet service protection function objects
Service Protection Object
Service Protection Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                              flags                  | OP  |SL |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 flags (4 bytes): service protection flags.
  * SL (2 bits): Sequence number length.
                 0b00: no sequence number
                 0b01: sequence number length of 16 bits
                 0b10: sequence number length of 28 bits

Replication Capability Object
Replication Capability Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                              flags                            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 Flags (4 bytes): unused.

Elimination Capability Object
Elimination Capability Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                              flags                            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 Flags (4 bytes): unused.

Ordering Capability Object
Ordering Capability Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                              flags                            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

 Flags (4 bytes): unused.

DetNet Service Flow Information Objects
DetNet Service Flow Identifier Object (MPLS)
DetNet Service Flow Identifier Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                             Flags                       |P|I|O|
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Flags (4 bytes):
 * I: Incoming flow
 * O: Outgoing flow
 * P: platform-label-space

Service Label Object
Service Label Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                        Service Label                          |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Service Label (4 bytes): S-Label, DetNet Service identifier with MPLS data plane.

DetNet Service Flow Identifier Object (IPv4)
DetNet Service Flow Identifier Object (IPv4) Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                             Flags                     |S|A|I|O|
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Flags (4 bytes):
 * I: Incoming flow
 * O: Outgoing flow
 * A: IPv4 flow identifier, including Source Address, Destination Address, Source Port, Destination Port, Protocol and Dscp
 * S: IPSec-spi

IPv4 Flow Identifier Object
IPv4 Flow Identifier Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                        Source Address                         |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                     Destination Address                       |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |         Source Port           |      Destination Port         |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |   Protocol    |     Dscp      |           RESERVED            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Source Address (4 bytes): IPv4 source address of the packet.
Destination Address (4 bytes): IPv4 destination address of the packet.
Source Port (2 bytes): Source port of the packet.
Destination Port (2 bytes): Destination port of the packet.
Protocol (1 byte): Protocol of the packet.
Dscp (1 byte): Differentiated Services Code Point.

DetNet Service Flow Identifier Object (IPv6)
DetNet Service Flow Identifier Object (IPv6) Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                             Flags                   |L|S|A|I|O|
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Flags (4 bytes):
 * I: Incoming flow
 * O: Outgoing flow
 * A: IPv6 flow identifier, including Source Address, Destination Address, Source Port, Destination Port, Protocol and Dscp
 * S: IPSec-spi
 * L: IPv6 flow label

IPv6 Flow Identifier Object
IPv6 Flow Identifier Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     +                                                               +
     |                                                               |
     +                         Source Address                        +
     |                                                               |
     +                                                               +
     |                                                               |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                                                               |
     +                                                               +
     |                                                               |
     +                       Destination Address                     +
     |                                                               |
     +                                                               +
     |                                                               |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |         Source Port           |      Destination Port         |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |   Protocol    |     Dscp      |           RESERVED            |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Source Address (16 bytes): IPv6 source address of the packet.
Destination Address (16 bytes): IPv6 destination address of the packet.
Source Port (2 bytes): Source port of the packet.
Destination Port (2 bytes): Destination port of the packet.
Protocol (1 byte): Protocol of the packet.
Dscp (1 byte): Differentiated Services Code Point.

IPv6 Flow Label Object
IPv6 Flow Label Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |                         IPv6 Flow Label                       |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

IPv6 Flow Label (4 bytes): The flow label value of the header. IPv6 only.

IPSec-SPI Object
IPSec-SPI Object Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Header               .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |              IPsec Security Parameters Index                  |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

IPSec-SPI (4 bytes): IPsec Security Parameters Index

DetNet Data Plane Considerations
MPLS Data Plane
DetNet echo request/reply messages in MPLS data plane, could encapsulate DetNet Capabilities Discovery Objects with typical TLV header format in place of the "DetNet Capabilities Discovery Header", as defined in {#detnet-cap-disc-obj}. The values of tlv types had not been defined yet.
MPLS TLV Header Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |             Type              |           Length              |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type (2 bytes): Tlv type
Length (2 bytes): Tlv Length

DetNet Capabilities Discovery Object (MPLS) Format

      0                   1                   2                   3
      0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     |             Type              |           Length              |
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
     .                                                               .
     .            DetNet Capabilities Discovery Data                 .
     .                                                               .
     +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

IP Data Plane
TBD.
IANA Considerations
NA.
Security Considerations
The security considerations described in [RFC8655] apply to the extensions defined in this document as well. This document does not raise new security issues.
References
Normative References
[RFC8655]

Deterministic Networking Architecture
N. Finn
P. Thubert
B. Varga
J. Farkas
October 2019
RFC 8655
DOI 10.17487/RFC8655
[I-D.ietf-detnet-oam-framework]

Framework of Operations, Administration and Maintenance (OAM) for Deterministic Networking (DetNet)
Greg Mirsky
Ericsson
Fabrice Theoleyre
CNRS
Georgios Z. Papadopoulos
IMT Atlantique
Carlos J. Bernardos
Universidad Carlos III de Madrid
Balazs Varga
Ericsson
János Farkas
Ericsson
8 January 2024
Internet-Draft draft-ietf-detnet-oam-framework-11
[I-D.ietf-detnet-mpls-oam]

Operations, Administration and Maintenance (OAM) for Deterministic Networks (DetNet) with MPLS Data Plane
Greg Mirsky
Ericsson
Mach Chen
Huawei
Balazs Varga
Ericsson
12 January 2024
Internet-Draft draft-ietf-detnet-mpls-oam-15
[I-D.ietf-detnet-ip-oam]

Operations, Administration, and Maintenance (OAM) for Deterministic Networks (DetNet) with IP Data Plane
Greg Mirsky
Ericsson
Mach Chen
Huawei
David L. Black
Dell EMC
14 February 2024
Internet-Draft draft-ietf-detnet-ip-oam-13
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
Informative References
[I-D.varga-detnet-service-sub-layer-oam]

Deterministic Networking (DetNet): OAM Functions for The Service Sub-Layer
Balazs Varga
Ericsson
János Farkas
Ericsson
Greg Mirsky
Ericsson
25 July 2022
Internet-Draft draft-varga-detnet-service-sub-layer-oam-03
Acknowledgements